/*
 * CourseForm.java
 *
 * Created on 27  2003 ., 13:04
 */

package com.fn.BikersLog;


import java.text.NumberFormat;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class AquaRouteWindow extends javax.swing.JDialog {
    
    private AquaRoute route;
    private boolean okPressed = false;
    
    /** Creates new form CourseForm */
    public AquaRouteWindow(java.awt.Dialog owner, AquaRoute route, boolean edit) {
        super(owner, true);
        this.route = route;
        initComponents();
        if (edit)
            setTitle(I18n.getMsg("aquaRouteForm.editTitle"));
        else
            setTitle(I18n.getMsg("aquaRouteForm.newTitle"));
        
        nameTextField.setText(route.getName());
        lengthTextField.setText(Utils.doubleToStr(Units.fromStdBDist(route.getLength())));
        currentTextField.setText(Utils.doubleToStr(Units.fromStdSpeed(route.getCurrentSpeed())));
        notesTextArea.setText(route.getNotes());
             
        Utils.centerWindow(this, owner);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        lengthTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        currentTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        imageEditor = new ImageEditor(route.getImage(), route.getImageStorage());

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel2.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel4.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setLabelFor(nameTextField);
        jLabel1.setText(I18n.getMsg("aquaRouteForm.name"));
        jLabel1.setMaximumSize(new java.awt.Dimension(330, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 4, 4);
        jPanel3.add(jLabel1, gridBagConstraints);

        nameTextField.setPreferredSize(new java.awt.Dimension(180, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 4, 0);
        gridBagConstraints.weightx = 1.0;
        jPanel3.add(nameTextField, gridBagConstraints);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setLabelFor(lengthTextField);
        jLabel2.setText(I18n.getMsg("aquaRouteForm.length"));
        jLabel2.setMaximumSize(new java.awt.Dimension(400, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel3.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(lengthTextField, gridBagConstraints);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText(I18n.getMsg("aquaRouteForm.current"));
        jLabel3.setMaximumSize(new java.awt.Dimension(510, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel3.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(currentTextField, gridBagConstraints);

        jLabel4.setText(I18n.getMsg("aquaRouteForm.notes"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 8, 4);
        jPanel3.add(jLabel4, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(250, 180));
        notesTextArea.setLineWrap(true);
        notesTextArea.setWrapStyleWord(true);
        notesTextArea.setPreferredSize(new java.awt.Dimension(300, 15));
        jScrollPane1.setViewportView(notesTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 4, 9, 0);
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(jScrollPane1, gridBagConstraints);

        jLabel5.setText(Units.getBDist().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 8);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel5, gridBagConstraints);

        jLabel6.setText(Units.getSpeed().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 8);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel6, gridBagConstraints);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab(I18n.getMsg("generic.propertiesTitle"), jPanel1);

        imageEditor.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jTabbedPane1.addTab(I18n.getMsg("generic.picture"), imageEditor);

        jPanel4.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        okPressed = false;
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        double distance = -1;
        try {
            distance = NumberFormat.getInstance().parse(lengthTextField.getText()).doubleValue();
        } catch (Exception e) { }
        if (distance <= 0.0) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("aquaRouteForm.invalidLength"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }

        double current = -1;
        try {
            current = NumberFormat.getInstance().parse(currentTextField.getText()).doubleValue();
        } catch (Exception e) { }
        if (distance < 0.0) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("aquaRouteForm.invalidCurrent"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        String name = nameTextField.getText();
        if (name.length() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("aquaRouteForm.invalidName"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }

        route.setName(name);
        route.setLength(Units.toStdBDist(distance));
        route.setCurrentSpeed(Units.toStdSpeed(current));
        route.setNotes(notesTextArea.getText());
        if (imageEditor.isImageChanged())
            route.setImage(imageEditor.saveImage());

        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed
    
    public static boolean edit(java.awt.Dialog owner, AquaRoute route) {
        AquaRouteWindow cw = new AquaRouteWindow(owner, route, true);
        cw.setVisible(true);
        cw.dispose();
        return cw.okPressed;
    }
    
    public static AquaRoute add(java.awt.Dialog owner, ImageStorage is) {
        AquaRouteWindow cw = new AquaRouteWindow(owner, new AquaRoute(is), false);
        cw.setVisible(true);
        boolean res = cw.okPressed;
        cw.dispose();
        if (res)
            return cw.route;
        else
            return null;
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField currentTextField;
    private com.fn.BikersLog.ImageEditor imageEditor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField lengthTextField;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
    
}
