/*
 * BikeRoutesListWindow.java
 *
 * Created on 5  2004 ., 12:50
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class BikeRoutesListWindow extends GeneralListWindow {
    
    private Log log;
    
    /** Creates a new instance of BikeRoutesListWindow */
    public BikeRoutesListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("bikeRoutesListForm.title"));
        this.log = log;
        itemsList.setModel(log.getCoursesList());
    }
    
    public static void execute(Frame owner, Log log) {
        BikeRoutesListWindow brw = new BikeRoutesListWindow(owner, log);
        brw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("bikeRoutesListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        Course course = CourseWindow.addCourse(this, log.getImageStorage());
        if (course != null) {
            log.getCoursesList().addCourse(course);
            itemsList.setSelectedIndex(log.getCoursesList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        Course course = log.getCoursesList().get(itemNo);
        if (CourseWindow.editCourse(this, course)) {
            log.getCoursesList().changeCourse(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getCoursesList().deleteCourse(itemNo);
        log.markAsUnsaved();
    }
    
}
