/*
 * BikesListWindow.java
 *
 * Created on 5  2004 ., 11:17
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class BikesListWindow extends GeneralListWindow {
    
    private Log log;
    
    /** Creates a new instance of BikesListWindow */
    public BikesListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("bikesListForm.title"));
        this.log = log;
        itemsList.setModel(log.getBikesList());
    }
    
    public static void execute(Frame owner, Log log) {
        BikesListWindow blw = new BikesListWindow(owner, log);
        blw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("bikesListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        Bike bike = BikeWindow.addBike(this, log.getImageStorage());
        if (bike != null) {
            log.getBikesList().add(bike);
            itemsList.setSelectedIndex(log.getBikesList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        Bike bike = log.getBikesList().get(itemNo);
        if (BikeWindow.editBike(this, bike)) {
            log.getBikesList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getBikesList().delete(itemNo);
        log.markAsUnsaved();
    }
}
