/*
 * CourseForm.java
 *
 * Created on 27  2003 ., 13:04
 */

package com.fn.BikersLog;


import java.awt.image.BufferedImage;
import java.io.File;
import java.text.NumberFormat;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class CourseWindow extends javax.swing.JDialog {
    
    private Course course;
    private boolean okPressed = false;
    private HeightProfile heightProfile;
    
    /** Creates new form CourseForm */
    public CourseWindow(java.awt.Dialog owner, Course course, boolean edit) {
        super(owner, true);
        this.course = course;
        heightProfile = new HeightProfile(course.getHeightsProfile());
        initComponents();
        if (edit)
            setTitle(I18n.getMsg("courseForm.editTitle"));
        else
            setTitle(I18n.getMsg("courseForm.newTitle"));
        
        nameTextField.setText(course.getName());
        double length;
        if (heightProfile.isEmpty())
            length = course.getLength();
        else {
            length = heightProfile.getLength();
            lengthTextField.setEnabled(false);
        }
        lengthTextField.setText(Utils.doubleToStr(Units.fromStdBDist(length)));
     
        String items[] = new String[5];
        for (int i = 0; i <= 4; i++)
            items[i] = I18n.getMsg("difficulty." + Integer.toString(i + 1));
        DefaultComboBoxModel comboBoxModel = new DefaultComboBoxModel(items);
        difficultyComboBox.setModel(comboBoxModel);
        difficultyComboBox.setSelectedIndex(course.getDifficulty() - 1);
        notesTextArea.setText(course.getNotes());
        
        Utils.centerWindow(this, owner);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        lengthTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        difficultyComboBox = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();
        jLabel5 = new javax.swing.JLabel();
        imageEditor = new ImageEditor(course.getImage(), course.getImageStorage());
        jPanel5 = new javax.swing.JPanel();
        heightProfileEditor = new HeightProfileEditor(heightProfile);
        jPanel2 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel3.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel3ComponentShown(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setLabelFor(nameTextField);
        jLabel1.setText(I18n.getMsg("courseForm.name"));
        jLabel1.setMaximumSize(new java.awt.Dimension(330, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        jPanel3.add(jLabel1, gridBagConstraints);

        nameTextField.setPreferredSize(new java.awt.Dimension(180, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 0);
        jPanel3.add(nameTextField, gridBagConstraints);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setLabelFor(lengthTextField);
        jLabel2.setText(I18n.getMsg("courseForm.length"));
        jLabel2.setMaximumSize(new java.awt.Dimension(400, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 4);
        jPanel3.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(lengthTextField, gridBagConstraints);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setLabelFor(difficultyComboBox);
        jLabel3.setText(I18n.getMsg("courseForm.difficulty"));
        jLabel3.setMaximumSize(new java.awt.Dimension(510, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 4);
        jPanel3.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(difficultyComboBox, gridBagConstraints);

        jLabel4.setText(I18n.getMsg("courseForm.notes"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        jPanel3.add(jLabel4, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(330, 200));
        jScrollPane1.setRequestFocusEnabled(false);
        notesTextArea.setLineWrap(true);
        notesTextArea.setWrapStyleWord(true);
        jScrollPane1.setViewportView(notesTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel3.add(jScrollPane1, gridBagConstraints);

        jLabel5.setText(Units.getBDist().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel5, gridBagConstraints);

        jTabbedPane1.addTab(I18n.getMsg("courseForm.route.title"), jPanel3);

        imageEditor.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jTabbedPane1.addTab(I18n.getMsg("courseForm.picture.title"), imageEditor);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel5.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel5.add(heightProfileEditor, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab(I18n.getMsg("courseForm.profile.title"), jPanel5);

        jPanel1.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel2.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void jPanel3ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel3ComponentShown
        if (! heightProfile.isEmpty()) {
            lengthTextField.setEnabled(false);
            double l = Units.fromStdBDist(heightProfile.getLength());
            lengthTextField.setText(Utils.doubleToStr(l));
        } else
            lengthTextField.setEnabled(true);
    }//GEN-LAST:event_jPanel3ComponentShown

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        okPressed = false;
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        double distance = -1;
        
        if (heightProfile.isEmpty()) {
            try {
                distance = NumberFormat.getInstance().parse(lengthTextField.
                        getText()).doubleValue();
            } catch (Exception e) { }

            if (distance <= 0.0) {
                JOptionPane.showMessageDialog(this, I18n.getMsg("courseForm.invalidLength"), 
                    I18n.getMsg("mainForm.title"), 
                    javax.swing.JOptionPane.ERROR_MESSAGE);
                return;
            }
        } else
            distance = heightProfile.getLength();

        String name = nameTextField.getText();
        if (name.length() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("courseForm.invalidName"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }

        course.setName(name);
        course.setLength(Units.toStdBDist(distance));
        course.setDifficulty(difficultyComboBox.getSelectedIndex() + 1);
        course.setNotes(notesTextArea.getText());
        if (imageEditor.isImageChanged())
            course.setImage(imageEditor.saveImage());
        course.setHeightsProfile(heightProfileEditor.getHeightProfile());

        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed
    
    public static boolean editCourse(java.awt.Dialog owner, Course course) {
        CourseWindow cw = new CourseWindow(owner, course, true);
        cw.setVisible(true);
        cw.dispose();
        return cw.okPressed;
    }
    
    public static Course addCourse(java.awt.Dialog owner, ImageStorage is) {
        CourseWindow cw = new CourseWindow(owner, new Course(is), false);
        cw.setVisible(true);
        boolean res = cw.okPressed;
        cw.dispose();
        if (res)
            return cw.course;
        else
            return null;
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox difficultyComboBox;
    private com.fn.BikersLog.HeightProfileEditor heightProfileEditor;
    private com.fn.BikersLog.ImageEditor imageEditor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField lengthTextField;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
    
}
