/*
 * EventsInDay.java
 *
 * Created on 16  2004 ., 10:46
 */

package com.fn.BikersLog;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import javax.swing.ListModel;

/**
 *
 * @author  asso
 */
public class EventsInDay implements MicroTableModel, ListModel {

    private Date day;
    private List events = null;
    
    /** Creates a new instance of EventsInDay */
    public EventsInDay(Date day) {
        this.day = day;
    }
    
    public void addEvent(Event event) {
        if (null == events)
            events = new ArrayList();
        events.add(event);
    }
    
    public void delEvent(Event event) {
        if (null != events)
            events.remove(event);
    }
    
    public Iterator getEvents() {
        if (null == events)
            events = new ArrayList();
        return events.iterator();
    }
    
    public Date getDay() {
        return day;
    }
    
    public boolean isEmpty() {
        return (null == events) || (0 == events.size());
    }
    
    public int getSize() {
        return (null == events) ? 0 : events.size();
    }
    
    public int getColumnCount() {
        int[] arr = Config.getCalendarColumns();
        return (null == arr) ? 0 : arr.length;
    }
    
    public Object getItem(int row, int column) {
        int[] arr = Config.getCalendarColumns();
        int itemNo = arr[column];
        Event event = (Event)events.get(row);
        if (itemNo == Event.COLUMN_TYPE)
            return event.getIcon();
        else
            return event.getColumnData(itemNo);
    }
    
    public int getRowCount() {
        return getSize();
    }
    
    public void addListDataListener(javax.swing.event.ListDataListener l) {
    }
    
    public Object getElementAt(int index) {
        return events.get(index);
    }
    
    public void removeListDataListener(javax.swing.event.ListDataListener l) {
    }
    
}
