/*
 * HeightProfileEditor.java
 *
 * Created on 17  2004 ., 14:33
 */

package com.fn.BikersLog;


import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class HeightProfileEditor extends javax.swing.JPanel {
    
    private HeightProfile heightProfile;
    
    /** Creates new form HeightProfileEditor */
    public HeightProfileEditor() {
        heightProfile = new HeightProfile();
        initComponents();
    }
    
    public HeightProfileEditor(HeightProfile heightProfile) {
        this.heightProfile = heightProfile;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        heightsView = new HeightsView(heightProfile);
        jToolBar2 = new javax.swing.JToolBar();
        openBtn = new javax.swing.JButton();
        saveBtn = new javax.swing.JButton();
        editProfileBtn = new javax.swing.JToggleButton();
        deleteBtn = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        add(heightsView, java.awt.BorderLayout.CENTER);

        openBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Open16.gif")));
        openBtn.setToolTipText(I18n.getMsg("heightProfileEditor.openHint"));
        openBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openBtnActionPerformed(evt);
            }
        });

        jToolBar2.add(openBtn);

        saveBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Save16.gif")));
        saveBtn.setToolTipText(I18n.getMsg("heightProfileEditor.saveHint"));
        saveBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveBtnActionPerformed(evt);
            }
        });

        jToolBar2.add(saveBtn);

        editProfileBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Edit16.gif")));
        editProfileBtn.setToolTipText(I18n.getMsg("heightProfileEditor.editHint"));
        editProfileBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editProfileBtnActionPerformed(evt);
            }
        });

        jToolBar2.add(editProfileBtn);

        deleteBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Delete16.gif")));
        deleteBtn.setToolTipText(I18n.getMsg("heightProfileEditor.deleteHint"));
        deleteBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteBtnActionPerformed(evt);
            }
        });

        jToolBar2.add(deleteBtn);

        add(jToolBar2, java.awt.BorderLayout.NORTH);

    }//GEN-END:initComponents

    public HeightProfile getHeightProfile() {
        return heightProfile;
    }
    
    public void setHeightProfile(HeightProfile heightProfile) {
        this.heightProfile = heightProfile;
        heightsView.setProfile(heightProfile);
    }
    
    private void deleteBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteBtnActionPerformed
        if (heightProfile.isEmpty())
            return;
        int res = JOptionPane.showConfirmDialog(Utils.findParentDialog(getParent()), 
                I18n.getMsg("heightProfileEditor.deleteConfirmation"),
                I18n.getMsg("mainForm.title"), JOptionPane.YES_NO_OPTION);
        if (res != JOptionPane.YES_OPTION)
            return;
        if (heightsView.isEdit()) {
            heightsView.setEdit(false);
            editProfileBtn.setSelected(false);
        }
        heightProfile.clear();
    }//GEN-LAST:event_deleteBtnActionPerformed

    private void editProfileBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editProfileBtnActionPerformed
        boolean edit = ! heightsView.isEdit();
        if (edit && heightProfile.isEmpty())
            heightProfile.setFlat(100.0);
        editProfileBtn.setSelected(edit);
        heightsView.setEdit(edit);
    }//GEN-LAST:event_editProfileBtnActionPerformed

    private void saveBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveBtnActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.addChoosableFileFilter(new SuffixFileFilter(".hpf", "fileFilter.hpf"));
        int ret = fc.showSaveDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            File f = fc.getSelectedFile();
            if ((! f.isFile()) && (f.getName().indexOf('.') < 0))
                f = new File(f.getAbsolutePath() + ".hpf");
            if (f.isFile()) {
                int res = JOptionPane.showConfirmDialog(this, 
                        I18n.getMsg("heightProfileEditor.overwriteConfirmation"), 
                        I18n.getMsg("mainForm.title"), JOptionPane.YES_NO_OPTION);
                if (res != JOptionPane.YES_OPTION)
                    return;
            }
            try {
                heightProfile.save(f);
            } catch (Exception e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog(this, 
                    I18n.getMsg("heightProfileEditor.saveError"));
            }
        }
    }//GEN-LAST:event_saveBtnActionPerformed

    private void openBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openBtnActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.addChoosableFileFilter(new SuffixFileFilter(".hpf", "fileFilter.hpf"));
        int ret = fc.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            try {
                heightProfile = new HeightProfile(fc.getSelectedFile());
                heightsView.setProfile(heightProfile);
            } catch (Exception e) {
                e.printStackTrace();
                JOptionPane.showMessageDialog(this, 
                    I18n.getMsg("heightProfileEditor.loadError"));
            }
        }
    }//GEN-LAST:event_openBtnActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton deleteBtn;
    private javax.swing.JToggleButton editProfileBtn;
    private com.fn.BikersLog.HeightsView heightsView;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JButton openBtn;
    private javax.swing.JButton saveBtn;
    // End of variables declaration//GEN-END:variables
    
}
