/*
 * ImageEditor.java
 *
 * Created on 11  2004 ., 18:40
 */

package com.fn.BikersLog;

/**
 *
 * @author  asso
 */
public class ImageEditor extends javax.swing.JPanel {

    private int imageId;
    private boolean imageChanged = false;
    private byte[] imageData;
    private boolean imageLoaded = false;
    private ImageStorage imageStorage;
    
    /** Creates new form ImageEditor */
    public ImageEditor() {
        imageId = -1;
        initComponents();
    }
    
    public ImageEditor(int imageNo, ImageStorage storage) {
        imageId = imageNo;
        imageStorage = storage;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jToolBar1 = new javax.swing.JToolBar();
        loadPictureBtn = new javax.swing.JButton();
        clearPictureBtn = new javax.swing.JButton();
        picture = new com.fn.BikersLog.Picture();

        setLayout(new java.awt.BorderLayout());

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });

        jToolBar1.setRollover(true);
        jToolBar1.setToolTipText(I18n.getMsg("imageEditor.picture.load"));
        loadPictureBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Open16.gif")));
        loadPictureBtn.setToolTipText(I18n.getMsg("imageEditor.picture.load"));
        loadPictureBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadPictureBtnActionPerformed(evt);
            }
        });

        jToolBar1.add(loadPictureBtn);

        clearPictureBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/fn/BikersLog/img/Delete16.gif")));
        clearPictureBtn.setToolTipText(I18n.getMsg("imageEditor.picture.clear"));
        clearPictureBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearPictureBtnActionPerformed(evt);
            }
        });

        jToolBar1.add(clearPictureBtn);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        add(picture, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        if (! imageLoaded) {
            imageLoaded = true;
            if ((imageId > 0) && (null == picture.getImage()))
                picture.setImage(imageStorage.getImage(imageId));
        }
    }//GEN-LAST:event_formComponentShown

    private void clearPictureBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearPictureBtnActionPerformed
        imageData = null;
        imageChanged = true;
        picture.setImage(null);
    }//GEN-LAST:event_clearPictureBtnActionPerformed

    private void loadPictureBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadPictureBtnActionPerformed
        ImageChooser.Result res = ImageChooser.openImage(this);
        if (null != res) {
            imageChanged = true;
            picture.setImage(res.image);
            imageData = res.data;
        }
    }//GEN-LAST:event_loadPictureBtnActionPerformed

    public boolean isImageChanged() {
        return imageChanged;
    }
    
    public int saveImage() {
        if (imageChanged)
            return (null == imageData) ? 0 : imageStorage.addImage(imageData);
        else
            return imageId;
    }
    
    public void update(java.awt.Graphics g) {
        formComponentShown(null);
        super.update(g);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton clearPictureBtn;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton loadPictureBtn;
    private com.fn.BikersLog.Picture picture;
    // End of variables declaration//GEN-END:variables
    
}
