/*
 * ImageStorage.java
 *
 * Created on 25  2004 ., 14:10
 */

package com.fn.BikersLog;


import java.awt.image.BufferedImage;
import java.io.InputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;


/**
 *
 * @author  asso
 */
public class ImageStorage {
    
    private DataFile file;
    private List imageNumbers;
    private int maxId;
    
    /** Creates a new instance of ImageStorage */
    public ImageStorage(DataFile f) {
        file = f;
        loadImagesList();
    }
    
    public int addImage(byte[] data) {
        maxId++;
        imageNumbers.add(new Integer(maxId));
        setImage(maxId, data);
        saveImagesList();
        return maxId;
    }
    
    private String getResName(int id) {
        return "img-" + Integer.toString(id);
    }

    public void setImage(int id, byte[] data) {
        file.setData(getResName(id), data);
    }
    
    public void removeImage(int id) {
        imageNumbers.remove(new Integer(id));
        file.remove(getResName(id));
        saveImagesList();
    }
    
    public BufferedImage getImage(int id) {
        try {
            return javax.imageio.ImageIO.read(file.getResourseInput(getResName(id)));
        } catch (Exception e) { }
        return null;
    }
    
    private void saveImagesList() {
        StringBuffer sb = new StringBuffer();
        boolean first = true;
        for (Iterator i = imageNumbers.iterator(); i.hasNext(); ) {
            if (first)
                first = false;
            else
                sb.append(' ');
            sb.append(((Integer)i.next()).toString());
        }
        try {
            file.setData("imglist", sb.toString().getBytes("UTF-8"));
        } catch (Exception e) { }
    }
    
    private void loadImagesList() {
        imageNumbers = new LinkedList();
        maxId = 0;
        try {
            StringTokenizer st = new StringTokenizer(new String(
                        file.getData("imglist"), "UTF-8"));
            while (st.hasMoreTokens()) {
                int num = Integer.parseInt(st.nextToken());
                if (num > maxId)
                    maxId = num;
                imageNumbers.add(new Integer(num));
            }
        } catch (Exception e) {
            return;
        }
    }
}
