/*
 * RidesDataSet.java
 *
 * Created on 31  2003 ., 23:47
 */

package com.fn.BikersLog;


import java.util.Date;
import com.fn.repway.RepException;
import com.fn.repway.Value;


/**
 *
 * @author  asso
 */
public class RidesDataSet extends EventsDataSet {
    
    /** Creates a new instance of RidesDataSet */
    public RidesDataSet(EventsList el, Date from, Date to) {
        super("rides", el, from, to);
    }
    
    public Value getValue(String name) throws RepException {
        RideEvent event = (RideEvent)this.event;
        if (name.equals("finish"))
            return new Value(Value.TIME, event.getFinish());
        else if (name.equals("date"))
            return new Value(Value.DATE, event.getStart());
        else if (name.equals("elapsed"))
            return new Value(Value.TIMEINT, event.getElapsed());
        else if (name.equals("distance"))
            return new Value(Units.fromStdBDist(event.getDistance()));
        else if (name.equals("speed"))
            return new Value(Units.fromStdSpeed(event.getAvgSpeed()));
        else if (name.equals("hr"))
            return new Value(event.getHeartRate());
        else if (name.equals("type"))
            return new Value(event.getRideTypeDescr());
        else if (name.equals("bike"))
            return new Value(event.getBike().getName());
        else if (name.equals("route"))
            return new Value(event.getCourse().getName());
        throw new RepException("Unknown field '" + name + "'");
    }
    
    protected boolean isSuitableEvent(Event event) {
        return event instanceof RideEvent;
    }
    
}
