/*
 * BikeRoutesListWindow.java
 *
 * Created on 5  2004 ., 12:50
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class SkiingRoutesListWindow extends GeneralListWindow {
    
    private Log log;
    
    /** Creates a new instance of BikeRoutesListWindow */
    public SkiingRoutesListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("skiingRoutesListForm.title"));
        this.log = log;
        itemsList.setModel(log.getSkiingRoutesList());
    }
    
    public static void execute(Frame owner, Log log) {
        SkiingRoutesListWindow srw = new SkiingRoutesListWindow(owner, log);
        srw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("skiingRoutesListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        SkiingRoute route = SkiingRouteWindow.add(this, log.getImageStorage());
        if (null != route) {
            log.getSkiingRoutesList().add(route);
            itemsList.setSelectedIndex(log.getSkiingRoutesList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        SkiingRoute route = log.getSkiingRoutesList().get(itemNo);
        if (SkiingRouteWindow.edit(this, route)) {
            log.getSkiingRoutesList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getSkiingRoutesList().delete(itemNo);
        log.markAsUnsaved();
    }
    
}
