/*
 * GeneralPane.java
 *
 * Created on 8  2004 ., 15:38
 */

package com.fn.BikersLog.prefs;


import com.fn.BikersLog.Config;
import com.fn.BikersLog.I18n;
import com.fn.BikersLog.LookAndFeelHelper;
import com.fn.BikersLog.Metrics;
import com.fn.BikersLog.Units;


/**
 *
 * @author  asso
 */
public class GeneralPane extends javax.swing.JPanel implements PreferencesPage {
    
    /** Creates new form GeneralPane */
    public GeneralPane() {
        initComponents();
        autoOpenCheck.setSelected(Config.getAutoOpenLast());
        splashCheck.setSelected(Config.getShowSplash());
        lafComboBox.setSelectedItem(LookAndFeelHelper.getCurrentLafName());
        unitsComboBox.setSelectedItem(Units.getMetrics());
        backupCheck.setSelected(Config.getCreateBackup());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        splashCheck = new javax.swing.JCheckBox();
        autoOpenCheck = new javax.swing.JCheckBox();
        backupCheck = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        lafComboBox = new javax.swing.JComboBox(LookAndFeelHelper.getLafList());
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        unitsComboBox = new javax.swing.JComboBox();

        setLayout(new java.awt.GridBagLayout());

        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        splashCheck.setText(I18n.getMsg("prefernecesForm.general.showSplash"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 4);
        add(splashCheck, gridBagConstraints);

        autoOpenCheck.setText(I18n.getMsg("preferencesForm.general.autoOpenLast"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 4);
        add(autoOpenCheck, gridBagConstraints);

        backupCheck.setText(I18n.getMsg("preferencesForm.general.backup"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 4);
        add(backupCheck, gridBagConstraints);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.X_AXIS));

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(16, 0, 16, 0);
        add(jPanel1, gridBagConstraints);

        lafComboBox.setPreferredSize(new java.awt.Dimension(220, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(lafComboBox, gridBagConstraints);

        jLabel1.setText(I18n.getMsg("prefernecesForm.general.laf"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jLabel1, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("preferencesForm.general.units"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jLabel2, gridBagConstraints);

        unitsComboBox.setModel(new javax.swing.DefaultComboBoxModel(Units.getAvailMetrics()));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(unitsComboBox, gridBagConstraints);

    }//GEN-END:initComponents

    public void apply() {
        Config.setAutoOpenLast(autoOpenCheck.isSelected());
        Config.setShowSplash(splashCheck.isSelected());
        String lfName = (String)lafComboBox.getSelectedItem();
        if (! Config.getLookAndFeel().equals(lfName)) {
            Config.setLookAndFeel(lfName);
            LookAndFeelHelper.setLookAndFeel(Config.getLookAndFeel());
            javax.swing.SwingUtilities.updateComponentTreeUI(
                com.fn.BikersLog.MainWindow.getInstance());
        }
        Metrics m = (Metrics)unitsComboBox.getSelectedItem();
        Config.setUnits(m.getIdent());
        Config.setCreateBackup(backupCheck.isSelected());
    }    
    
    public void install(javax.swing.JPanel parent) {
        parent.add(this, java.awt.BorderLayout.CENTER);
    }    
    
    public void remove(javax.swing.JPanel parent) {
        parent.remove(this);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox autoOpenCheck;
    private javax.swing.JCheckBox backupCheck;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JComboBox lafComboBox;
    private javax.swing.JCheckBox splashCheck;
    private javax.swing.JComboBox unitsComboBox;
    // End of variables declaration//GEN-END:variables
    
}
